v0.11.0 - 03/13/2013

  !! NOTE: This version requires Minecraft 1.5.0 release or higher!

   * Configurable Stairwells. (orphu)

   * Configurable Secret Rooms. (orphu)

   * Three new Stairwells:
     TripleStairs and TowerLadder (djchrisblue)
     Scaffolding (orphu)

   * New Ruin: HouseFrame (djchrisblue)

   * Five new Features:
     CircleOfSkulls, Cell, Farm, Chapel (djchrisblue)
     ConstructionArea (orphu)

   * Two new Secret Rooms:
     SecretArmory (JiFish/orphu)
     SecretEnchantingLibrary (JiFish/orphu)

   * New Entrance: RuinedFane (djchrisblue)

   * New option: exit_portal. This will create a portal to the surface built
     with command blocks. Works in vanilla! (orphu)

   * New option: hidden_spawners. This will hide the random spawners behind
     walls. This is on by default in the hard_mode config. (orphu)

   * New options: SpawnCount, SpawnMaxNearbyEntities, SpawnMinDelay,
     SpawnMaxDelay, SpawnRequiredPlayerRange allow greater control over
     spawners. (JiFish)

   * New option: double_treasure. Doubles the loot roll in treasure rooms.
     Mainly for multiplayer. (JiFish)

   * New option: enchant_system. Controls which enchantments can show up on
     enchanted items. See default.cfg for detail. (JiFish)

   * Themed name generator for various things in the dungeon. (JiFish)

   * Custom paintings on maps as loot. (JiFish)

   * Enchanted books as loot. (JiFish)

   * Added fireworks as loot. (JiFish)

   * Lots more unique magic books, armor, and an axe. (JiFish)

   * Improved SecretSepulchure room. (orphu)

   * 1.5 items. (JiFish)

   * Updated 1.5 item enchantments (orphu/JiFish)

   * Ruins have more randomness to position and size (djchrisblue, orphu)

   * Renamed hard_mode to fill_caves. (orphu)

   * Support for mods that use high block IDs. (orphu)

   * Removed heads.txt in favour of loading items from NBT files. (JiFish)

   * Removed (broken) multiverse support. (orphu)

   * Added more orange. (JiFish)

   * Fixed old music disc names. (JiFish)

   * Anvils are less common in forges. (JiFish)

   * Added fortunes to fortune cookies. (JiFish)

   * Fixed many map icons. (orphu)

   * Fixed Nether Brick blocks being air. (orphu)

                                                                                                                                                                                               3,20          Top
   * Fixed Nether Brick blocks being air. (orphu)

   * Fixed an issue with adding maps to a world with no maps. (orphu)

   * CellBlock signs are now written books hidden around the dungeon. (orphu)

   * Fixed a bug with structure detection that caused it to miss some
     mines and villages. (orphu)

   * Fixed a bug with the relight progress bar counting too high. (orphu)

   * Removed lava streams in pit rooms. (orphu)

   * Maps now have a display name. (orphu)

   * Enchanted loot now honors the amount field (JiFish)


v0.10.4 - 11/22/2012

   * Fixed custom spawners on case sensitive systems. (orphu)

   * Added some additional armed and armored skeletons, fast zombies, and
     zombie villagers. (orphu)

   * Fix for books and spawners when run from outside the mcdungeon
     directory. (orphu)

   * Secret rooms can contain alchemy labs. (orphu)

   * Added some missing tiles for HTML maps (orphu)

   * The default config produces fewer hall piston traps. (orphu)

   * CustomKnight no longer has a chance to drop his gear. (orphu)

   * Added a fine collection of enchanted swords. (orphu)

v0.10.3 - 11/12/2012

   * Fixed bug with blank written books. (JiFish)

   * Heads can appear in sarcophagi. (JiFish)

v0.10.2 - 11/10/2012

   * Mob spawners can now pick more difficult mobs by depth. (orphu)
     (see default.cfg)

   * Forges can sometimes contain cauldrons. (orphu)

   * New Linux and OS X stand-alone distributions.

v0.10.1 - 11/05/2012

   * Fixes from pymclevel dealing with chunk saving bugs.

v0.10.0 - 11/04/2012

  !! NOTE: This version requires Minecraft 1.4.2 release or higher!

   * Fixes a potentially chunk corrupting bug with books. (JiFish)

   * Over 50 new books. (JiFish)

   * 1.4 Mobs.  (JiFish)

   * Additional 1.4 loot in shipping configs (JiFish)

   * New example config "more_mobs" adds a lot more monsters. (JiFish)

   * Updates to pymclevel. Better Anvil support and memory leak fixes. (orphu)
     As a result MCDungeon now requires Python 2.7.

   * Forges can contain anvils. (JiFish)

   * New wall blocks used in various places (columns, balconies) (JiFish)

   * Potions of Night Vision and Invisibility. (JiFish)

   * Emerald ore can be found in cave-ins. (JiFish)

   * Custom magic items can be named in game, and include lore text. (JiFish)
     (see magic_items.txt)

   * Custom potion effects. (JiFish)
     (see potions.txt)

   * Custom dye colors for armor. (JiFish)
     (see dye_colors.txt)

   * Heads of famous (and not so famous) players can be found as loot! (JiFish)
     (see heads.txt)

v0.9.1 - 09/20/2012

  !! NOTE: This version requires Minecraft 1.3.1 release or higher!

   * Fixed a division by zero error when all chunks are too near or to far.

   * Fixed a crash when structures: is blank in the config file.

   * Enchanting probabilities work like 1.3 now.

   * Fixed LavaSlime (Magma Cube) spawners. (Thanks JiFish!)

   * Added custom spawner types. Use an NBT editor (like NBTEdit)
     to create custom mob types in the spawners directory. These can be
     used to create custom mob spawners. A few examples are included:
     Charged Creepers, Angry Pig Zombies, and Tougher Zombies. (zombies
     with a potion affect) (JiFish)

   * Hard mode config will use more difficult mob spawners. (JiFish)

   * Maximum levels is now 42. (which will not fit in a 256 tall world)

   * 59 new written books as loot. Collect 'em all! (JiFish)

   * Fixed some item stacking and missing items. (JiFish)

   * Added Chainmail to tier 2 chests. (JiFish)

   * Added all music discs avalible in survival (excl. Disc 11) to max
     tier. (JiFish)

   * Added enchanted golden apple and glistering melon to max tier. (JiFish)

   * Removed Iron Golem Egg (Hasn't worked since release 1.2) (JiFish)

   * Studies (secret rooms) now contain unique loot. (JiFish)

   * Two new config options for dungeon maps:

     maps: Chance to generate a map for a given level
     mapstore: Where to place maps (if you use bukkit/multiworld)

   * The default easy_mode config will always generate maps. 
     hard_mode will never generate maps. And all other example
     configs will generate level maps 80% of the time. 

   * New wood floor type. (JiFish)

   * Bridges will use different types of wood. (JiFish)

v0.9.0 - 08/02/2012

  !! NOTE: This version requires Minecraft 1.3.1 release or higher!

   * Added 1.3 blocks, items, and treasure.

   * Fixed a bug calculating depths with perfectly flat chunks.

   * Fixed floating blocks on some ruins.

   * It now snows on ruins in winter biomes.

   * Ruins will change materials depending on the biome they
     are in.

   * Biome aware versions of pyramids and towers.

   * Potions now appear in treasure chests.

   * Potions and monster eggs can now appear in dispenser traps.

   * The contents of dispenser traps are configurable.

   * Sand traps now use tripwire and appear more commonly.

   * Removed tower_ruin config option. 

   * Custom enchanted items. Cookies of fortune, efficient fishes, swords
     of smite X, feathers of feather falling, etc.
     See magic_items.txt for details. 

   * Added a new chandelier type in great halls.

   * More use of upside down stairs and slabs. 

   * New room feature: Mess Hall

v0.8.3 - 07/18/2012

   * Fixed bug with regenerate and the --force-bury option.

   * Fixed lots of caching bugs.

   * Fixed ruins being set too low into the ground.

   * Dungeons in swamp and jungle biomes will grow vines.

v0.8.2 - 07/16/2012

   * Fixed vines making towers too tall.

   * Additional Fixes for pymclevel. 

   * renamed --skip-bury to --force-bury and added a force_bury config
     file option.

   * Many performance improvements. 

   * Initial dungeon scanning is 3-4X faster.

   * Initial chunk scanning is 2-3X faster.

   * Dungeon and chunk scanning is now cached between runs, and only
     chunks that have changed are re-scanned. This results in huge
     speed increases when running MCDungeon more than once, even on
     large maps. 

   * MCDungeon now uses much less memory. Scanning a 5000x5000 map
     (111,222 chunks) uses less than 200MB of RAM.

   * Added wood plank types.

v0.8.1 - 03/03/2012

   * Added 1.2 blocks: Circle Stone, Redstone Lamps, Fire Charge, 
     Jungle wood, and Bottle of Enchanting.

   * Added circle brick to dungeon and mossy brick meta materials.

   * Spiral stairs now use upside down slabs for a cleaner look. 

   * Arrow traps sometimes shoot fire charges. 

   * Added Spawn Ocelot, Spawn Iron Golem, and Bottle o' Enchanting
     as treasure.

   * Bottles o' Enchanting can appear in coffins.

   * Added icons for circle stone brick, lamps, and upper half slabs.

v0.8.0 - 03/02/2012

  !! NOTE: This version requires Minecraft 1.2.3 release or higher!

   * Added missing torch icons.

   * Some code clean up.

   * Basic "Anvil" map support. (it's kinda slow and memory inefficient
     right now, but it works)

   * Fixed doors to work in 1.2.

   * Replaced End Stone with Sandstone in crypts and sepulchres. 

   * Improved the look of arch ruins and tower entrances with upside
     down stairs. 

   * Silverfish are a lot more common in the default configs. 

v0.7.1 - 01/22/2012

  !! NOTE: This version requires Minecraft 1.1.0 release or higher!

   * Torches now properly attach to walls. (No more floating torches)

   * Fixed whitespace parsing bug for enchant level.

   * Added bow enchantments. 

   * Added spawn eggs.

   * Added --spawn option to override spawn location. This allows you to
     specify an origin instead of the default spawn location. 

v0.7.0 - 11/20/2011

  !! NOTE: This version requires Minecraft 1.0.0 release or higher!

  !! NOTE 2: This version also breaks backward compatibility with dungeons
     generated with older versions of MCDungeon. To reuse old maps, use 0.6.0
     to delete the maps before running 0.7.0. 

  !! NOTE 3: This version also breaks backward compatibility with old configs.
     The loot table format has changed. If you want to use old configs, you can
     but you'll have to replace all the loot tables with a list from one of the
     standard configs. 

   * New treasure room: Crypt

   * New treasure room: EndPortal

   * New secret room type: Sepulchre

   * New floor types: StoneBrick and BrokenStoneBrick

   * New room: GreatHall (two versions with multiple variations each)

   * Removed --bury option and replaced it with --skip-bury. The default when
     using --offset now is to bury the dungeon. 

   * Revamped the cardinal directions to match beta 1.9 and 1.0.0 release.

   * CellBlock rooms can now have a variety of floor types.

   * Adds various blocks and items in beta 1.9 and 1.0.0 release.

   * Tweaked min/max distance and room ratios in the default configs. With the
     addition of mines and ravines, there are fewer "good" chunks to place
     dungeons into. The new defaults will result in more dungeons being
     placed in small maps by default.

   * Portcullises can be fence, nether fence, or iron bars.

   * Arenas now host Blaze.

   * Spider Lairs now host cave spiders.

   * Added additional materials for Stairwell, Columns, Pool, and Dais. 

   * Loot tables now handle multiple items per line (ie: add one of a list) and
     will enchant armor, weapons, and tools. See default.cfg for details.

v0.6.0 - 09/22/2011

   * New room feature: Mushrooms.

   * Tweaked loot tables to better fit the 1.8 hunger/healing mechanics.

     * Removed meats (they would spoil in a dungeon)

     * Moved apples around (hey maybe they are magical!)

     * Added more wheat and mushrooms for craftable food. 

     * Less bread.

     * Tier 0 can contain a bowl to help crafting stew.      

     * Added pumpkin and melon seeds, and ender pearls to top level chests.

   * New cfg option: silverfish replaces stone, cobblestone, and stone brick
     blocks with silverfish look-alikes. 

   * Reworked many things to incorporate new 1.8 blocks. 

   * Updates to pymclevel fix lighting errors for 1.8 blocks. (vines, chests,
     etc)

   * New meta materials can be used for wall, floors, etc:

     * meta_mossycobble: Cobblestone with veins of moss. (like pre 0.6.0 cobble)

     * meta_mossystonebrick: Stone bricks with random cracks and veins of moss.

     * meta_stonedungeon: Changes as you go deeper. Starts as something like
                          mossy stone bricks and turns to cobble and mossy
                          cobble as levels get deeper.

   * Added blocks: Silverfish Stone, Stone Brick, Mossy Stone Brick,
     Cracked Stone Brick, Iron Bars, Glass Pane, Melon, Pumpkin Stem,
     Melon Stem, Vines, Fence Gate, Brick Stairs, Stone Brick Stairs

   * MultiVerse signs work differently and are (hopefully) compatible with MV 2.

   * SpiderLair, ThroneRoom, and Arena now generate portals when mvportal is
     configured. 

v0.5.2 - 08/30/2011

   * New cfg option: secret_door sets the material to use for the moving parts
     of secret doors. Handy if you want to set walls to be something immovable,
     like bedrock. 

   * Two new murals for ThroneRoom.

   * New treasure room: Arena

   * Fixed arrow traps sometimes breaking secret room halls. 

v0.5.1 - 08/24/2011

   * Fixed bug where secret rooms could cut off stairwells on the second to
     last level.

v0.5.0 - 08/22/2011

   * Secret rooms!

   * New cfg option: secret_rooms controls how often secret rooms show up.

   * New room feature: Arcane

   * New room feature: Dais

   * New room feature: Forge

   * Added customizable treasure rooms.

   * New treasure room: SpiderLair

   * New treasure room: ThroneRoom

   * Bugfix: Passing -1 for number of levels caused a crash.

v0.4.0 - 08/13/2011

   * Optimizations to the location search algorithm. Major performance 
     improvements when placing multiple dungeons. 

   * Configurable structure detection. Chunks marked with player structures
     will no longer be eligible for dungeon placement.

   * Chunks that are too high will be excluded from searches. 

   * New entrance types: Square tower (and ruined), round tower (and ruined),
     step pyramid, and evil runestones.

   * Entrance stairwells will sometimes be wood, sometimes be slabs for a bit
     more variety.

   * Dungeon info is now saved with the map, allowing the tool to detect
     dungeons generated in previous runs.

   * New subcommand: add - adds new dungeons to the world.

   * New subcommand: list - lists dungeons in the world.

   * New subcommand: delete - Deletes old dungeons from the world. Chunks
     containing dungeons are deleted and allowed to regenerate back to 
     their natural state. (you need to load the map into Minecraft for the
     chunks to be regenerated)

   * New subcommand: regenerate - Regenerates dungeons in place. (with a few
     caveats) Dungeons will have a new maze layout, new rooms, restocked
     chests and spawners, and can even use a different config file. 

     - Surface structures will never be regenerated. This includes ruins and
       entrances. Any damage done to these structures by players or mobs will
       not be repaired. 

     - Any chests at the surface within the area of the dungeon (even ones
       not placed by MCDungeon! Be careful!) will be refreshed with tier
       zero loot

     - Regenerated dungeons will never link up with any natural caverns.
       this is because the area underground is refilled with stone and ores,
       blocking off any natural caves that may have connected. 

     - You cannot use hard mode on regenerated dungeons. 

   * Interactive mode supports add, list, delete, and regenerate.

   * Added --dir option for interactive mode. Use this to override the
    default path to your Minecraft save directory.

v0.3.1 - 07/24/2011

   * New cfg option: resetting_hall_pistons. Defaults to true. 

v0.3.0 - 07/20/2011

   * New documentation wiki: http://mcdungeon.wikkii.com/

   * Added Spruce Sapling, Birch Sapling, Spruce Leaves, Birch Leaves, Powered
     Rail, Detector Rail, Sticky Piston, Piston, Trapdoor, Map, and Shears to
     items.txt. Renamed "Web" to "Cobweb"

   * Will now search the current directory and then the user's save directory
     for world files. You no longer have to type out the full path if the
     world is in the standard Minecraft save directory. (All OSes)

   * Rooms can be larger than one chunk. They can also be irregularly shaped. 

   * Massive changes to the maze generation algorithm to accommodate multi-tile
     rooms and treasure rooms. 

   * The minimum dungeon size is now 4x4x1. This is to accommodate large tile
     types and treasure rooms. 

   * New room type Basicx2x2: Large 2x2 tile version of Basic. 

   * New room types: Cavern and CavernLarge. Creates randomly sized cavern
     shaped rooms. These are large, and will be a random shape and size.

   * New room types: SandstoneCavern SandstoneCavernLarge. Like caverns, but
     made of sandstone and sand floors.

   * New room types: NaturalCavern and NaturalCavernLarge. The wall of this
     cavern will be the naturally occurring blocks in the surrounding area.
     These may link up with natural caves surrounding the dungeon (unless
     hard mode is used).

   * New treasure room. (more will be added)

   * New room type: CellBlock

   * Added new piston-based traps. (See hall_piston_traps in the config)
 
   * New standard config: caverns

   * More updates to pymclevel handle lighting on tall grass and additional 
     oddball compression of chunks.

   * Chunks that are too high will be excluded from the placement algorithm.
     This keeps towers from being cut off at the height limit. 

   * External noise module is no longer required. (perlin.py is now bundled)

   * Tweaks, tweaks, and more tweaks. 

   * Bugfix: Fixed a problem parsing ranges when Z was fixed and X
     was a range.

   * Bugfix: Fixed bug with multi-dungeon not properly disabling -e 

v0.2.3 - 05/30/2011

    * Updated pymclevel files to 2011-05-01 (commit 20223cae8edfc47a8723)
      This will hopefully help with reading some types of levels that were
      edited or generated with certain other tools. (Seibai, and others)

v0.2.2 - 05/26/2011

    * Fixed an issue where multi-dungeon would bail out early when
      maximize_distance was true and the map had a very irregular shape. 

v0.2.1 - 05/26/2011
  
    * Added a bounds to prevent crashing when placing dungeons on very high
      plateaus.

v0.2.0 - 05/26/2011

    * Multiple dungeons can now be drawn in one pass. Use the --number option
      to specify the number of non-overlapping dungeons that the tool should
      attempt to generate. -1 will fill in as many dungeons as possible given 
      the min/max chunk settings in your config file. This is also supported in
      interactive mode. 

    * Surface level ruins. Ruins are chosen from a customizable weighted list
      like other dungeon features. 

    * X, Z, and LEVELS options will now take ranges for random sizes. 
      example: ./mcdungeon.py MAP 3-5 2-5 5-8 -n 2
      Will generate two random dungeons between 3x2x5 and 5x5x8 in size.
      This also works in interactive mode.

    * Sandbars now merge with the existing world better. Sand will only be
      drawn on water or ice blocks. 

    * Lava pits can sometimes have lava streaming from the ceiling. 

    * Skeleton balconies.

    * Defective arrow traps can sometimes explode. 

    * Pit rooms can contain falling sand traps.

    * Added --bury option to calculate Y coordinate when using --offset.

    * Added --entrance option to specify the location of the tower when using
      --offset. 

    * New cfg option: torches_position will specify the height of torches on
      walls.

    * New cfg option: tower_ruin will make the entrance towers crumble. 

    * New cfg option: ruin_ruins. Setting this to False will skip any attempt
      to "ruin" surface structures. 

    * New cfg option: maximize_distance will attempt to place dungeons as far
      apart as possible when rendering multi-dungeons.

    * MCDungeon will now look in its current running directory for support
      files and configs. (you no longer need to cd to its directory before
      running it.)

    * More progress info and verbose output for troubleshooting.

    * Bugfix: Chests hovering above subfloor and half blocks in lava pits and
      treasure rooms.

    * Several other bugs and unhandled exceptions fixed. 

v0.1.0 - 04/27/2011

    * More interesting lava floors.

    * Revamped chest and spawner placement. These can now appear in lava and
      other rooms with very little floor space. 

    * Pit rooms can now be circular. (and possibly more shapes in the future)

    * Images used for tiles in HTML maps are now 12x12. More tiles added.

    * All new maze generation algorithm. How convoluted mazes are can now be
      controlled in the config file. Entry and exit stairs are now guaranteed
      to be as far away from each other as possible on a given level.
  
    * New config option: loops - Controls how many loops the maze will have.
      0 = no loops, just a few branches. 100 = A grid. Values around 20-30
      will produce mazes similar to the old algorithm. 

    * Bridges in pit rooms now always connect all hallways. Pit floors now
      never have bridges since there are other ways to cross them. 

    * New config option: portcullises_closed - Percentage of portcullises that
      will be rendered closed. 0 = none, 100 = all.

    * The final bounds of the dungeon are printed on the last line. Handy for
      folks running WorldGuard or similar. 

    * Single hall corridor dead ends are now special cave in rooms that can
      contain ores in similar proportions to the world. (coal is common,
      diamond and lapis are rare, etc)

    * The default tower entrance has a few improvements, and will now build a
      sand bar around itself if placed in water. 

    * More verbose output in certain situations.

    * Configuration files are now kept in a directory named "configs" in the 
      MCDungeon directory. Several example configs have been added. 

    * New config option: hard_mode - Hard mode will fill in caves under and
      around the dungeon in an attempt to concentrate monster spawns inside the
      walls of the dungeon. This works best on larger maps that already have 
      chunks within the start area generated. Medium to large sized 
      dungeons with 5-8 levels will work best as well. 

    * Interactive mode will now prompt for which configuration file you want 
      to use. 
 
    * Fixed a crash bug if the tower option was set too high. 

    * Spider webs.

v0.0.4 - 04/14/2011

    * Fixed the "subfloor" setting not reading properly from the .cfg file.

v0.0.3 - 04/1/2011

    * A few tweaks to the default .cfg file.

    * Removed --world option and replaced it with a positional argument.

    * Added --interactive option. This will prompt for SAVEDIR, Z, X, 
          and LEVEL

    * Added batch file for windows to start in interactive mode.

    * Added a little more progress feedback.

v0.0.2 - 03/31/2011

    * Added Cookie and Locked Chest to items.txt.

    * Added Cookie to default loot tables.

    * Reworked the --offset option. It now takes three args instead
      if just one. 

    * Z, X, and LEVELS args now accept -1 as a value. This will 
      cause the tool to pick random values for these. Z and X will
      between 2 and the maximum distance between dist_min and dist_max
      in the .cfg file. Levels will be between 2 and 8. This should 
      maximize the chance that the dungeon will fit into the map, 
      unless the map has a ton of very shallow chunks around spawn.

v0.0.1 - 03/30/2011

    * Initial release!
